<?php

namespace HCM\AVL\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;
use HCM\Util\DateUtil;
use HCM\AVL\Repository\GerenciamentoRepository;
use Teknisa\Model\Avaliacao\Entities\Participaval;
use Teknisa\Model\Avaliacao\Entities\Avaliacaogeral;

class GerenciamentoService {
    
    protected $entityManager;
    protected $gerenciamentoRepository;
    
    public function __construct(EntityManager $entityManager, GerenciamentoRepository $gerenciamentoRepository) {
        $this->entityManager = $entityManager;
        $this->gerenciamentoRepository = $gerenciamentoRepository;
    }
    
    public function deleteRegistro($row, $response) {
        $params = array();
        $nravaliacao     = $row['NRAVALIACAO'];
        $nrcombquestaval = $row['NRCOMBQUESTAVAL'];
        $nrparcexecaval  = $row['NRPARCEXECAVAL'];
        $nrparcavaliado  = $row['NRPARCAVALIADO'];
        $nrorg           = $row['NRORG'];
        $nrcombquestaval = $row['NRCOMBQUESTAVAL'];
        
        //UPDATE PARTICIPAVAL
        $paramsUpdateParticipaval = array(':P_IDSITUACAOAVAL'  => 'PENDENTE',
                                ':P_DTCONCLUSAOAVAL' => NULL,
                                ':P_VRRESULTAVALIA'  => NULL,
                                ':P_CDTIPORESU'      => NULL,
                                ':P_NRPARCEXECAVAL'  => $nrparcexecaval,
                                ':P_NRPARCAVALIADO'  => $nrparcavaliado,
                                ':P_NRCOMBQUESTAVAL' => $nrcombquestaval,
                                ':P_NRORG'           => $nrorg);
        $this->gerenciamentoRepository->updateParticipaval($paramsUpdateParticipaval);
        
        //APAGA REGISTROS FILHOS DA EXECUÇÃO SELECIONADA
        $paramsDeleteRespavaliacao = array('P_NRAVALIACAO'=>$nravaliacao,
                                            'P_NRCOMBQUESTAVAL'=>$nrcombquestaval,
                                            'P_NRPARCEXECAVAL'=>$nrparcexecaval,
                                            'P_NRPARCAVALIADO'=>$nrparcavaliado);
        $this->gerenciamentoRepository->deleteRespavaliacao($paramsDeleteRespavaliacao);
        
        //APAGA REGISTROS DA EXECUÇÃO SELECIONADA
        $paramsDeleteExecavaliacao = array('P_NRAVALIACAO'=>$nravaliacao, 
                                            'P_NRCOMBQUESTAVAL'=>$nrcombquestaval,
                                            'P_NRPARCEXECAVAL'=>$nrparcexecaval, 
                                            'P_NRPARCAVALIADO'=>$nrparcavaliado);
        $this->gerenciamentoRepository->deleteExecavaliacao($paramsDeleteExecavaliacao);
    }
    
    public function reverterStatus($row, $response){
        $nravaliacao     = $row['NRAVALIACAO'];
        $nrcombquestaval = $row['NRCOMBQUESTAVAL'];
        $nrparcexecaval  = $row['NRPARCEXECAVAL'];
        $nrparcavaliado  = $row['NRPARCAVALIADO'];
        $nrorg           = $row['NRORG'];
        $nrcombquestaval = $row['NRCOMBQUESTAVAL'];
        
        $participaval = $this->entityManager->getRepository(Repositories::PARTICIPAVAL)->findOneBy(array('nrorg'=>$nrorg, 'nravaliacao'=>$nravaliacao, 'nrparcavaliado'=>$nrparcavaliado, 'nrparcexecaval'=>$nrparcexecaval));

        $participaval->setNrorg($nrorg);
        $participaval->setNravaliacao($nravaliacao);
        $participaval->setNrcombquestaval($nrcombquestaval);
        $participaval->setNrparcavaliado($nrparcavaliado);
        $participaval->setNrparcexecaval($nrparcexecaval);
        $participaval->setIdsituacaoaval('PENDENTE');
        $participaval->setIdativo('S');
        $this->entityManager->persist($participaval);
        $this->entityManager->flush();
    }
    
    public function getAvaliacaoGeral($nravaliacao, $nrorg){
        return $this->entityManager->getRepository(Repositories::AVALIACAOGERAL)->findOneBy(array('nrorg' => $nrorg, 'nravaliacao' => $nravaliacao));
    }
    
    public function getAvaliacoes($nrorg){
        $params = array(':P_NRORG' => $nrorg);
        return $this->gerenciamentoRepository->getAvaliacoes($params);
    }
    
}