<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;
use HCM\Util\Util;
use HCM\Util\HCMParameters;
use HCM\Geral\Repository\DateTime;

class RateioLancamentoRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    public function getVinculosEstrutLegal(
                $nrorg,
                $dtmescompetenc,
        int     $nrestrutlegal,
                $nrvinculom  = null

    ) { 

        if(is_array($nrvinculom)) {
            $condNrvinculom = "AND vh.nrvinculom IN (" . implode(",",$nrvinculom) . ")";
        } else {
            $condNrvinculom = null;
        }

        $gpevinculoh =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculoh';
        $gpevinculom =  'Teknisa\Model\Gestaopessoas\Entities\GpeVinculom';
    $sql = <<<SQL
        SELECT vm, vh
        FROM $gpevinculom vm
        JOIN $gpevinculoh vh WITH vh.nrvinculom = vm.nrvinculom
                        AND vh.nrorg = vm.nrorg
                        AND vh.dtmescompetenc = (SELECT MAX(vhh.dtmescompetenc)
                                                   FROM $gpevinculoh vhh
                                                  WHERE vhh.dtmescompetenc <= :p_dtmescompetenc
                                                    AND vhh.nrorg = vh.nrorg
                                                    AND vhh.nrvinculom = vh.nrvinculom)
        WHERE vm.nrorg = :p_nrorg
        AND (vm.dtrescisaovinc >= :p_dtmescompetenc OR vm.dtrescisaovinc IS NULL)
        AND (vh.nrestrutlegal = :p_nrestrutlegal or :p_nrestrutlegal IS NULL)
        $condNrvinculom

        
SQL;
        $params = array(
            'p_dtmescompetenc'      => $dtmescompetenc,
            'p_nrorg'               => $nrorg,
            'p_nrestrutlegal'       => $nrestrutlegal
        );
        $resultado = $this->entityManager->createQuery($sql)->execute($params);

        $vinculo = array();
        $vinculom = Repositories::GPE_VINCULOM;
        foreach ($resultado as $key => $vinc) {
            if($vinc instanceof $vinculom){
                $vinc->historico = $resultado[$key+1];
                $vinculo[] = $vinc;
            }    
        }
        return $vinculo;
    }
}
