<?php
namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;
use Geral\Entities\fornecedor;
use HCM\Util\HCMParameters;
use HCM\Util\Util;

class FornecedorService {
    
    protected $fornecedor;
    protected $now;
    
    public function __construct(EntityManager $entityManager, Environment $environment, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->hcmParameters = $hcmParameters;
        $this->now = new \DateTime();
    }
    
    public function salvarAdicao($fornecedor) {
        
        $remove_mask = array("." => "","-" => "","/" => "");
        $fornecedor['NRINSJURFORN'] = strtr($fornecedor['NRINSJURFORN'],$remove_mask);
        
        $obj = new \Geral\Entities\Fornecedor();
        $obj->setNrorg($fornecedor['NRORG']);
        $obj->setCdforneced($fornecedor['CDFORNECED']);
        $obj->setIdativo($fornecedor['IDATIVO']);
        $obj->setNrinsjurforn($fornecedor['NRINSJURFORN']);
        $obj->setNmfantforn($fornecedor['NMFANTFORN']);
        $obj->setNmrazsocforn($fornecedor['NMRAZSOCFORN']);
        $obj->setDtinclusao($this->now);
        $obj->setCdoperinclusao($fornecedor['CDOPERINCLUSAO']);
        $obj->setNrorginclusao($fornecedor['NRORGINCLUSAO']);
        $obj->setDtultatu($this->now);
        $obj->setCdoperultatu($fornecedor['CDOPERULTATU']);
        $obj->setNrorgultatu($fornecedor['NRORGULTATU']);
        $obj->setIdfortranspvale('S');
        $obj->setIdutilzipaf('S');
        $obj->setIdeanprodmar('N');
        $obj->setIdtpenvaffor('1');
        $obj->setIdutiledinf('N');
        $obj->setIdbloqcmpsaffor('S');
        $obj->setIdconsfinal('N');
        $obj->setIdutqtdispforn('N');
        $obj->setIdnpermancotint('N');
        $obj->setIdlocalforncad('F');
        $obj->setIdsexoprofi('I');
        $obj->setIdprofipossveic('N');
        $obj->setIdavaliaprofi('0');
        $obj->setIdcomparqxmlfor('S');
        $obj->setIdobrigaean('N');
        $obj->setIdgerafdtent('N');
        $obj->setIdgercontpgt('S');
        $obj->setIdfornauto('N');
        $obj->setIdendemisfor('P');
        $obj->setIdendcfopfor('P');
        $obj->setIdforncontri('S');
        $obj->setIdsitucada('A');
        $obj->setIdpripubforn('V');
        
        switch(strlen($fornecedor['NRINSJURFORN'])){
            case 11:
                $obj->setIdtpijurforn('F');
            break;
            case 14:
                $obj->setIdtpijurforn('J');
            break;
            default:
                $obj->setIdtpijurforn('I');
            break;
        };
        
        $obj->setIdtpdescforn('C');
        $obj->setIdtipoforn('N');
        $obj->setIdformpgforn('T');
        $obj->setIdutlalvforn('N');
        $obj->setIdtipopagaprof('CONTAPAGAR');
        $obj->setIdpercmpdfe('N');
        $obj->setIdagrubolfor('N');
        $obj->setIdligextforn('S');
        $obj->setIdforninter('N');
        $obj->setIdcontraforn('N');
        $this->entityManager->persist($obj);
        $this->entityManager->flush();
    }

    public function salvarEdicao($dataset) {
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        $cdforneced = $dataset["CDFORNECED"];
        $this->fornecedor = \Geral\Entities\Fornecedor::findOneByCdfornecedAndNrorg($cdforneced, $nrorg);
            
        if($this->fornecedor) {
            
            $remove_mask = array("." => "","-" => "","/" => "");
            $dataset['NRINSJURFORN'] = strtr($dataset['NRINSJURFORN'],$remove_mask);
            
            switch(strlen($dataset['NRINSJURFORN'])){
                case 11:
                    $this->fornecedor->setIdtpijurforn('F');
                break;
                case 14:
                    $this->fornecedor->setIdtpijurforn('J');
                break;
                default:
                    $this->fornecedor->setIdtpijurforn('I');
                break;
            
            };
            
            $this->fornecedor->setNrinsjurforn($dataset['NRINSJURFORN']);
            $this->fornecedor->setIdativo($dataset['IDATIVO']);
            $this->fornecedor->setNmfantforn($dataset['NMFANTFORN']);
            $this->fornecedor->setNmrazsocforn($dataset['NMRAZSOCFORN']);
            $this->fornecedor->setDtultatu($this->now);
            $this->fornecedor->setCdoperultatu($dataset['CDOPERULTATU']);
            $this->fornecedor->setNrorgultatu($dataset['NRORGULTATU']);
            $this->entityManager->persist($this->fornecedor);
            $this->entityManager->flush();
        }else{
            throw new \Exception("Fornecedor não existe.");
        }
    }
}