/*
-- ====================================================================
-- SISTEMA         : EMPRSTIMO/LOCAO DE PRODUTOS
-- DATA DA CRIAO : 30/04/2002
-- PROGRAMADOR     : Ptrick
-- OBJETIVOS       : GERAR EXEMPLARES DE UM PRODUTO
-- ====================================================================
-- @C:\WIN_PRJ\SQL\ORACLE\9900_EMPSTP_INSERE_EXEMPLAR.SQL
-- ====================================================================
*/
 CREATE OR REPLACE PROCEDURE INSERE_EXEMPLAR_03
          ( P_CDFILIAL    IN  EXEMPLAR.CDFILIAL%TYPE,
            P_CDPRODUTO   IN  PUBLPROD.CDPRODUTO%TYPE,
            P_CDARVPROD   IN  PRODUTO.CDARVPROD%TYPE,
            P_CDPUBLPROD  IN  PUBLPROD.CDPUBLPROD%TYPE,
            P_QTEXEMPLAR  IN  NUMBER,
            P_EXEMPINI    IN  VARCHAR )
 IS
    V_CDEXEMPLAR     VARCHAR(05);
    V_NRINICIAL      VARCHAR(05);
    V_QTEXEMPLAR     NUMBER;
    V_CDEXISTE       VARCHAR(05);
    V_SGPUBLPROD     VARCHAR(20);
    V_EXEMPLAR       VARCHAR(05);
 BEGIN
   V_CDEXEMPLAR    := '';
   V_QTEXEMPLAR    := 1;
   V_NRINICIAL     := P_EXEMPINI;
   V_CDEXISTE      := 0;
   WHILE V_QTEXEMPLAR <= P_QTEXEMPLAR
    LOOP
      SELECT NVL(MAX(CDEXEMPLAR), '0') AS CDEXISTE
      INTO V_CDEXISTE
      FROM
         EXEMPLAR
      WHERE
         (CDFILIAL   = P_CDFILIAL  ) AND
         (CDPRODUTO  = P_CDPRODUTO ) AND
         (CDPUBLPROD = P_CDPUBLPROD) AND
         (CDEXEMPLAR = V_NRINICIAL);
      /*-----*/
      WHILE V_CDEXISTE <> '0'
        LOOP
           V_NRINICIAL := V_NRINICIAL + 1;
           V_NRINICIAL := LPAD(V_NRINICIAL, 05, '0');
           SELECT NVL(MAX(CDEXEMPLAR), '0') AS CDEXISTE
           INTO V_CDEXISTE
           FROM
              EXEMPLAR
           WHERE
              (CDFILIAL   = P_CDFILIAL  ) AND
              (CDPRODUTO  = P_CDPRODUTO ) AND
              (CDPUBLPROD = P_CDPUBLPROD) AND
              (CDEXEMPLAR = V_NRINICIAL);
        END LOOP;
      /*-----*/
      /* SIGLA DO EXEMPLAR */
      SELECT MAX(B.SGPUBLPROD) AS NOME
      INTO V_SGPUBLPROD
      FROM
         PUBLPROD B
      WHERE
         (B.CDPRODUTO  = P_CDPRODUTO)    AND
         (B.CDPUBLPROD = P_CDPUBLPROD);
      /*-----*/
      IF V_CDEXISTE = '0' THEN
         V_EXEMPLAR      := LPAD(V_NRINICIAL, 05, '0');
      ELSE
         V_EXEMPLAR      := LPAD(V_CDEXISTE, 05, '0');
      END IF;

      INSERT INTO EXEMPLAR
         (CDFILIAL, CDPRODUTO, CDPUBLPROD, CDEXEMPLAR, NMEXEMPLAR, IDEXEMPLAR, IDEXEMEMPRES)
      VALUES
         (P_CDFILIAL, P_CDPRODUTO, P_CDPUBLPROD, V_EXEMPLAR, P_CDARVPROD||V_SGPUBLPROD||V_EXEMPLAR, 'A', 'N');
      COMMIT;
      V_NRINICIAL  := V_EXEMPLAR + 1;
      V_QTEXEMPLAR := V_QTEXEMPLAR + 1;
    END LOOP;
 END
;

/
